##########
# This code is supplementary material belonging to the paper "Analysing 
# Irresolute Multiwinner Voting Rules with Approval Ballots via SAT Solving",
# published in ECAI-2020.
##########
# This program generates SAT clauses in CNF in DIMACS format that express
# certain desirable properties of multiwinner approval voting rules.
# SAT-solving these generated clauses then allows you to either find a
# suitable voting rule or an impossibility result of these properties.
##########
# Authors: Adriaan de Vries & Boas Kluiving
##########
# File: dimacser.py
##########

def dimacs(clauses, num_literals, outpath):
    num_clauses = len(clauses)
    with open(outpath, 'w') as f:
        f.write("p cnf {} {}\n".format(num_literals, num_clauses))
        for clause in clauses:
            f.write("{} 0\n".format(' '.join([str(x) for x in clause])))
